#April Fools Script
#By Einlanzers

import esm
import time
from org.bukkit.entity import Player
from org.bukkit.entity import Animals

max_distance = 10
shoot_delay = 4
last_prune = -1
animallist = {}

def entity_target(ev):
  target = ev.getTarget()
  if not isinstance(target, Player):
    return True
  entity = ev.getEntity()
  if isinstance(entity, Animals):
    return True
  return False

def player_move(ev):
  global last_prune
  curtime = int(time.time())
  if curtime - last_prune > 600:
    animallist.clear()
    last_prune = curtime
  player = ev.getPlayer()
  server = esm.server
  world = server.getWorlds()[0]
  for livingentity in world.getLivingEntities():
    if not isinstance(livingentity, Animals):
      continue
    ploc = player.getLocation()
    floc = livingentity.getLocation()
    dist = distance(ploc, floc)
    if dist > max_distance:
      continue
    livingentity.setTarget(player)
    id = livingentity.getEntityId()
    if id in animallist and curtime - animallist[id] < shoot_delay:
      continue
    livingentity.shootArrow()
    animallist[id] = curtime
  return True

def distance(loca, locb):
  x1 = loca.getX()
  y1 = loca.getY()
  z1 = loca.getZ()
  x2 = locb.getX()
  y2 = locb.getY()
  z2 = locb.getZ()
  return ((x2-x1)**2 + (y2-y1)**2 + (z2-z1)**2)**0.5
